﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<EPiServer.Shell.Web.Mvc.BootstrapperViewModel>" %>
<%@ Import Namespace="EPiServer.Framework.Web.Mvc.Html"%>
<%@ Import Namespace="EPiServer.Framework.Web.Resources"%>
<%@ Import Namespace="EPiServer.Framework.Serialization" %>
<%@ Import Namespace="EPiServer.Shell.Navigation" %>
<%@ Import Namespace="EPiServer.Shell.Navigation.Internal" %>
<%@ Import Namespace="EPiServer.Shell.Web.Mvc.Html" %>
<%@ Import Namespace="EPiServer.Shell.UI.Web.Mvc.Html" %>
<%@ Import Namespace="EPiServer.Shell.UI.Web.Resources" %>
<%@ Import Namespace="EPiServer.Labs.ContentManager" %>
<%@ Register Src="ReactApp.ascx" TagName="ReactApp" TagPrefix="WebControl" %>

<script runat="server">
    protected override void OnPreInit(EventArgs e)
    {
        base.OnPreInit(e);
        MasterPageFile = "../../../Shell/Views/Shared/Sleek.Master";
    }
</script>

<asp:Content ContentPlaceHolderID="TitleContent" runat="server"><%: Model.ViewTitle %></asp:Content>

<asp:Content ContentPlaceHolderID="HeaderContent" runat="server">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <%= Page.ClientResources("navigation", new[] {ClientResourceType.Style}) %>
    <%= Html.RequiredClientResources("BootstrapperHeader") %>
</asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">
    <%= Html.CreatePlatformNavigationMenu() %>

    <script type="text/javascript">
        if (window.NodeList && !NodeList.prototype.forEach) {
           NodeList.prototype.forEach = Array.prototype.forEach;
        }

        function ensureNavigationSelected() {
            var currentView = location.hash;
            var navigationItems = document.querySelectorAll(".epi-pn-navigation a.mdc-tab");

            navigationItems.forEach(function (node) {
                var currentItemUrl = node.href;
                var isActive = currentView && currentItemUrl.endsWith(currentView);
                node.classList.toggle("mdc-tab--active", isActive);
                var childNodes = node.querySelectorAll(".mdc-tab-indicator");
                childNodes.forEach(function (childNode) {
                    childNode.classList.toggle("mdc-tab-indicator--active", isActive);
                });
            });
        }

        window.addEventListener("hashchange", ensureNavigationSelected);

        function selectActiveTab() {
            function waitForNavigationInitialized() {
                var navigationEl = document.querySelectorAll("body > .epi-pn-navigation");
                if (navigationEl.length > 0) {
                    observer.disconnect();

                    navigationEl = navigationEl[0];
                    function waitForTabsToLoad () {
                        var tabs = navigationEl.querySelectorAll(".mdc-tab");
                        if (tabs.length > 0) {
                            observer.disconnect();

                            // wait for all tabs to be rendered
                            setTimeout(function () {
                                ensureNavigationSelected();
                            }, 50);
                        }
                    }

                    // wait until tabs are rendered
                    observer = new MutationObserver(waitForTabsToLoad);
                    observer.observe(navigationEl, { attributes: false, childList: true, subtree: true });
                    waitForTabsToLoad();
                }
            }

            // wait for React to render main navigation element
            var observer = new MutationObserver(waitForNavigationInitialized);
            observer.observe(document.body, { attributes: false, childList: true, subtree: true });
            waitForNavigationInitialized();
        }

        selectActiveTab();
    </script>

    <div <%= Html.ApplyFullscreenPlatformNavigation(Model.GetClassName()) %> >
        <script type="text/javascript">
            window.externalGridContentEdit = {
                onEditItem: function () { alert("Loading application"); },
                onSetContentLanguage: function () { },
                onCancelReview: function () { alert("Loading application"); },
                onTranslate: function () { alert ("Loading application"); },
                onCreateContent: function () { alert("Loading application"); }
            }
        </script>
        <% if (Model.ViewName == ContentManagerView.ViewName)
           { %>
            <script type="text/javascript">
                <%= Model.GetSerializedContentManagerSettings() %>
                <%= Model.GetSerializedContentManagerResources() %>
            </script>
            <WebControl:ReactApp runat="server"/>
        <% } %>
        <div data-dojo-type="dijit/layout/BorderContainer" id="rootContainer" gutters="false" style='padding: 0;height: 100%; width: 100%; <%= Model.ViewName == ContentManagerView.ViewName ? "display: none;" : "" %>'>
            <div data-dojo-type="epi/shell/widget/LicenseInformation" region="top"></div>
            <div id="applicationContainer" class="epi-applicationContainer" data-dojo-type="epi/shell/widget/Application" region="center" style="width: 100%; height: 100%;"></div>
        </div>
    </div>
</asp:Content>

<asp:Content ContentPlaceHolderID="ScriptContent" runat="server">
    <%= Page.ClientResources("navigation", new[] {ClientResourceType.Script}) %>
    <%--Add the scripts required for bootstrapping the app. Anything else will be loaded lazily by the ModuleManager --%>
    <%= Html.ModuleScripts(Model.Modules.GetStartupModules(Model.ModuleName)) %>
    <script type="text/javascript">
        require(["epi/shell/Bootstrapper", "epi/shell/HashWrapper", "epi/shell/applicationSettings"], function(Bootstrapper, HashWrapper, applicationSettings) {
            // all properties should work in Content Manager mode
            applicationSettings.isInContentManagerMode = true;
            //we don't want url hashes from epi
            HashWrapper.prototype._onContextChange = function () {};
            HashWrapper.prototype.setHash = function () {};

            var settings = <%= Html.SerializeObject(Model.Modules, KnownContentTypes.Json).Replace("<", "&lt;").Replace(">", "&gt;") %>,
                viewSettings = <%= Html.SerializeObject(Model.ViewSettings, KnownContentTypes.Json).Replace("<", "&lt;").Replace(">", "&gt;") %>,
                bootStrapper = new Bootstrapper(settings);

            /*bootStrapper.initializeApplication("<%: Model.ViewName %>", "<%: Model.ModuleName %>", viewSettings).then(function() {*/
            bootStrapper.initializeApplication("<%: Model.ViewName %>", "CMS", viewSettings).then(function() {
                require([
                        "dojo/_base/connect",
                        "dojo/parser",
                        "dijit/registry",
                        "dijit/layout/BorderContainer",
                        "dijit/layout/ContentPane",
                        "epi/shell/widget/GlobalMenu",
                        "epi/shell/widget/Application",
                        "epi/shell/widget/LicenseInformation",
                        "epi/shell/widget/ApplicationContentPane",
                        "dojo/domReady!"],
                    function (connect, parser, registry) {

                        parser.parse();

                        // Trigger layout when the global navigation changes its layout.
                        connect.subscribe("/epi/shell/globalnavigation/layoutchange", null,  function() {
                            registry.byId("rootContainer").layout();
                        });
                    });
            });
        });
    </script>

</asp:Content>
